# -*- coding: utf-8 -*-
"""
Created on Tue Dec 13 09:28:23 2016

@author: akibdpt
"""

from sortal import (transformSet, rule, primitiveSort, point3D, vector3D, lineSegment3D, disjunctiveSort, affineTransform)
from sympy import pi, sin, cos
from api.api_create import create
from api.sort_types import sort_types

create = create()
    
def rule1():

    v1 = vector3D(-1, -1, 0)
    v2 = vector3D(-1, 1, 0)
    v3 = vector3D(1, 1, 0)
    v4 = vector3D(1, -1, 0)
    
    v5 = vector3D(-1, -1, 0)
    v6 = vector3D(-1, 1, 0)
    v7 = vector3D(1, 1, 0)
    v8 = vector3D(1, -1, 0)
    
    v9 = vector3D(-0.6, -1, 0)
    v10 = vector3D(-1, 0.6, 0)
    v11 = vector3D(0.6, 1, 0)
    v12 = vector3D(1, -0.6, 0)
    
    #######################################################
    
    formP1 = create.pointForm(sort_types['pointSort3D'], 0.6, 1, 0)
    formP2 = create.pointForm(sort_types['pointSort3D'], 0.28, 0.92, 0)
    
    formL1_set = [v1, v2, v3, v4]
    formL1 = create.polygonForm(sort_types['lineSeg3D'], formL1_set)
    
    formL2_set = [[v5, v6], [v6, v7], [v7, v8], [v8, v5], [v9, v10], [v10, v11], [v11, v12], [v12, v9]]
    formL2 = create.lineSegForm(sort_types['lineSeg3D'], formL2_set)

    # LHS
    forms1 = [formL1, formP1]
    formM1 = create.metaForm(sort_types['disjunctive3D'], forms1)
    
    # RHS
    forms2 = [formL2, formP2]
    formM2 = create.metaForm(sort_types['disjunctive3D'], forms2)

    r = rule('Rule 1', 'Rotates square and point by a certain angle, decreases its size, and inscribes it inside the previous match', formM1, formM2)
    return r