# -*- coding: utf-8 -*-
"""
Created on Wed Sep 14 09:24:33 2016

@author: akibdpt
"""
from __future__ import division
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import absolute_import

from copy import deepcopy

class paramSet():
    type = 'paramSet'
    def __init__(self):
        self.parameters = {}
        self.conditions= {}
        self.results = {}
        self.keys = {}
        self.lhs = None
        self.rhs = None
        
        self.rule = None
        self.transform = None
        
        self.id = None
        self.current = None
    
    def isEmpty(self):
        return len(self.parameters) == 0
        
    def __eq__(self, other):
        return self.parameters == other.parameters and self.conditions == other.conditions
        
    def __str__(self):
        return str(self.parameters)
        return str(self.parameters)+'|'+ str(self.conditions)
        
    def duplicate(self):
        newTr = paramSet()
        newTr.parameters = self.parameters
        newTr.conditions = self.conditions
        """
        for i in self.parameters:
            newTr.parameters[i] = self.parameters[i]
        for i in self.conditions:
            newTr.conditions[i] = self.conditions[i]
        """
        newTr.lhs = self.lhs
        newTr.rhs = self.rhs
        return newTr
            
        
    def printVal(self):
        for i in self.parameters:
            print(i, self.parameters[i])
        
    def add(self, sort, name, value):
        if name == 'value':
            raise ValueError

        key = sort.name+'|'+name
        if key not in self.parameters:

            self.parameters[key] = value

        elif not self.parameters[key] == value:
            raise ParameterNameError('parameter name '+name+' is repeated in the left hand side')

        return True
        
    def merge(self, other):
        for i in other.parameters:
            if not i in self.parameters:
                self.parameters[i] = other.parameters[i]
        for i in other.conditions:
            if not i in self.parameters:
                self.conditions[i] = other.conditions[i]
        
    def retrieve(self, sort, name):
        key = sort.name+'|'+name
        if key not in self.parameters and self.lhs is not None:
            return None
        result = self.parameters[key]
        return result
        
    def getState(self, delayable):
        return self.conditions[str(delayable)]
        
    def delay(self, delayable, sort, value):
        self.conditions[str(delayable) + '|' + str(value)] = [delayable, sort, value]
            
    """
    def resolveDelay(self, delayable, value):
        delayKey = str(delayable) + '|' + str(value)
        if delayKey in self.conditions:
            del self.conditions[delayKey]
    """
    
    def resolveDelays(self):
        result = True
        delayables = list(self.conditions.keys())
        for delay in delayables:
            if not self.conditions[delay][0].delayedMatch(self, self.conditions[delay]):
                #print(self.conditions[delay])
                result = False
        return result
    
    def resolveSimpleDelays(self):
        result = True
        delayables = list(self.conditions.keys())
        for delay in delayables:
            check = self.conditions[delay][0].simpleDelayedMatch(self, self.conditions[delay])
            if not check:
                result = False
            elif check is True:
                self.conditions.pop(delay)
                
        return result
    
    def apply(self, element):
        return element.edit(self)

class ParameterNameError(Exception):
    def __init__(self, message = ''):
        super(ParameterNameError, self).__init__(message)
